import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;

public class Play
{
    private final static String DELIMITERS = " .?!()[]{}|/&\\,;:-\'\"\t\n\r";

    private String fileName;

    public Play( String fileName )
    {
        this.fileName = fileName;
    }

    public int countWords( CountedFeature test ) throws IOException
    {
        BufferedReader inputFile = new BufferedReader(
                                       new FileReader( fileName) );
        int wordCount = 0;

        while( true )
        {
            String buffer = inputFile.readLine();
            if ( buffer == null ) break;

            buffer = buffer.toLowerCase();
            StringTokenizer words = new StringTokenizer( buffer, DELIMITERS );
            while( words.hasMoreTokens() )
	    {
                String word = words.nextToken();
                if ( test.hasFeature( word ) )
                    wordCount++;
            }
        }

        return wordCount;
    }

    public int startsWith( char targetChar ) throws IOException
    {
        return countWords(
                  new StartsWith( targetChar ) );
    }

    public int wordsOfLength( int targetLength ) throws IOException
    {
        return countWords(
                  new OfLength( targetLength ) );
    }

    public int numberOfPalindromes() throws IOException
    {
        return countWords(
                  new IsAPalindrome() );
    }

    public String name()
    {
        return fileName;
    }
}
